// Global Minimization

// These functions provide a gradient minimization

function map %fv (t; f, x, v) := f(x+t*v);

function vmin (f:string, x:real vector, v:real vector, 
	tstart:number, tmax:number=1, tmin:number=epsilon)
## Minimize f(x+t*v)
	y=f(x);
	t=tstart;
	repeat
		ynew=f(x+t*v);
		while ynew<y;
		t=t*2;
		until t>tmax;
	end;
	t=fmin("%fv",0,t;f,x,v);
	return {x+t*v,t};
endfunction
