
comment

*****************
Created : 02/2008
By      : Benoua Mohamed
last Revision :02/2009
*****************

functions to simulate a random walk in Hall  ...
with Illustrations ...

endcomment

relax

function Randomize()
## ... change the seek of random numbers
i= RndBetween(100,10000);
	for j=1 to i;
                 j=IntRnd(i);
	end;
return 0;
endfunction

function IntRnd(x)
## IntRnd(x) Return a random Integer between 0 & x
return round(random(1,1)*x,0);
endfunction


function RndBetween(x,y)
## IntRndBetweenXY(x,y) Return a random Integer Between X & Y
return min(x,y)+ IntRnd(abs(x-y));
endfunction


function Track(m=6,n=6)
## return a  (Vector V(n))  random Track of the walk In hall(mxn)  
## mxn are dimension of the hall
  v=zeros(1,n);

    v(1,1)=RndBetween(1,m);
    khatwa=v(1,1);     .. //khatwa = Step  

    for i=2 to n;
	if khatwa==1; 
		v(1,i)=RndBetween(0,1);         ..// keep the walker inside the hall
	elseif khatwa==m;                                       
		v(1,i)=RndBetween(-1,0);        ..//Keep   ""     ""             ""              "" 
	else;
		v(1,i)=RndBetween(-1,1);
	endif;
	khatwa =khatwa +v(1,i);
    end;	
	return v;
endfunction   


function MoreTracks(m=6,n=6,k=500)
## return a Sample of Tracks  with size k.
	
     w=zeros(1,m);

	for i=1 to k;
		v=Track(m,n);
		f=sum(v);
		w(f)=w(f)+1;
	end;
	return w;
endfunction
	
function plotTrack(v,d=0)
## plot the Track v , d is the speed walking
## set d=1 to see slowly ...
	w=cumsum(v);
	hold on; 
	for i=1 to cols(w);
		plotbar(i,w(1,i),1,1);
		wait(d);		
	end;	
endfunction

function plotHall(m,n)
## plot the Hall(m,n) for walking .. 
	v=zeros(n,m);
	clg;
	setplot([1,rows(v)+1,1,cols(v)+1]);
	xplot();
endfunction


function prb2getk(m,n,k)
## return the probability that k is the finish  on the walk
	if (k> m) or (k<1) then;
           return "wrong value for k !!!";
	endif;

	v=ones(1,m);
	for i=1 to n-1;
		v=nextstep(v);
	end;
   return v(1,k)/sum(v);
endfunction

function nextstep(v)
## used by prb2getk
	w=v; i=1;
		for i= 1 to cols(v);
			if i ==1 then;
				w(1,i)=v(1,i)+v(1,i+1);
			elseif i ==cols(v);
				w(1,i)=v(1,i)+v(1,i-1);
			else;
				w(1,i)=v(1,i-1)+v(1,i)+v(1,i+1);
			endif;
		end;
	return w;
endfunction

function nbrTracks(m,n)
## Return the Number of All differrent tracks IN Hall(m,n)
	v=ones(1,m);
	for i=1 to n-1;
		v=nextstep(v);
	end;
   return sum(v);
endfunction
		
function kTracks(m,n,k)
## Return the Number of all tracks that stop In the K row
if (k> m) or (k<1) then;
           return "wrong value for k !!!";
	endif;

	v=ones(1,m);
	for i=1 to n-1;
		v=nextstep(v);
	end;
   return v(1,k);
endfunction

		
