function errorplot(x:real vector,y:interval,yreal=none,a=none,b=2,c=none,d=2, ...
r=0,grid=1, square=0,...
color=1,thickness=1,style=none,add=0,points=0,filled=1,fillcolor=7,...
outline=1,fillstyle="#",title="",xl=none,yl=none)
## errorplot produces a filled plot of the curves given by x and y as data.
## y has to be a vector or matrix of intervals. the intervals get filled.
## the plot can be overlayed with a curve given in yreal as data.
## many of the plot2d options work in errorplot too.
l=length(x);
if l<>length(y) then 
error("x and y have to be of the same length");
endif
if typeof(yreal)==2 then if l<>length(yreal) then
error("x and yreal have to be of the same length");
endif; endif
if r>0 then
 a=-r; b=r; c=-r; d=r;
else
 if a==none then
   a=x[1]; b=x[-1];
 endif
endif
ia=find(x,a+epsilon());
if ia==0 then
 ia=1
else 
 if !x[ia]~=a then ia=ia+1;endif
endif
ib=find(x,b+epsilon());
//a=x[ia]; b=x[ib];//a somewhat unfortunate solution to a minor problem; probably not necessary any more
x=x[ia:ib];
y=y[:,ia:ib];
if typeof(yreal)==2 then
 yreal=yreal[ia:ib];
endif
if c==none then 
 c=min(min(left(y))'); d=max(max(right(y))'); //necessary since totalmin does not act as gracious as min on NANs
 if typeof(yreal)==2 then
  c=min(yreal|c); d=max(yreal|d);
 endif
endif
if !filled then outline=1;endif
{cr,cg,cb}=getrgb(fillcolor);
add=add-1;
mxrow=rows(y);
loop 1 to mxrow
 ix=nonzeros(!isNAN(left(y[#,:])));
 x1=x[ix]; x1=x1|flipx(x1); 
 y1=y[#,ix]; y1=left(y1)|flipx(right(y1)); 
 if !filled then
  x1=x1|(x1[1]);
  y1=y1|(y1[1]);
 endif
 if fillcolor<16 then
  cc=fillcolor+#-1;
  if cc>15 then cc=cc-14;endif
 else
  i=#/mxrow;
  cc=rgb(1+i*(cr -1),1+i*(cg-1),1+i*(cb-1));
 endif
 plot2d(x1,y1,a=a,b=b,c=c,d=d,grid=grid,square=square,...
 filled=filled,fillcolor=cc,style=fillstyle,add=add+#,color=cc,outline=outline,title=title,xl=xl,yl=yl);
end
if typeof(yreal)==2 then  //matrix
plot2d(x,yreal,color=color,style=style,thickness=thickness,add=1,points=points)
else plot()
endif
endfunction
