// Histogram Plots

comment
Histogram plots. 
endcomment

// Calling these functions is obsolete, since plot2d provides the
// functionality with the bar parameter.

function histo (d:real vector, n:index=10, 
	integer:integer=0, even:integer=0, v:real vector=none)
## Computes {x,y} for histogram plots.
##
## d is an 1xm vector.
##
## Returns two vectors based on data vector d in n intervals
## x - End points of the intervals (equispaced n+1 points)
## y - The number of data in the subintervals (frequencies)
##
## integer=1 - for distributions on integer
## even=1 - better for evenly spaced discrete distributions
## To be used for plot2d and the bar style.
##
## v : intervall boundaries (ordered).
##
## The plot functions plot2d has parameters distribution=1, histgram=1
## to achieve the same effect.
##
## See: plot2d
	if v!=none then
		return {v,count(find(v,d),length(v))};
	else	
		mi=min(d); ma=max(d);
		if even then dc=(ma-mi)/(2*(n-1)); mi=mi-dc; ma=ma+dc; endif;
		if mi~=ma then ma=mi+1; endif;
		if integer then n=floor(ma-mi)+1; ma=ma+0.9999; endif;
		x=zeros(1,n); y=zeros(1,n); h=(d-mi)/(ma-mi)*n;
		c=count(h,n+1); c[n]=c[n]+c[n+1]; y=c[1:n];
		xx=linspace(mi,ma,n);
	endif;
	return {xx,y};
endfunction;


function histogram (d,n=10,grid=0,ticks=1,width=4,integer=0)
## Plots a histogram of the data d with n intervals.
##
## The minimal and maximal value of form an interval, which is divided
## into n points. The number of data in each of the n subintervals is
## displayed. d is an 1xm vector.
##
## Obsolete function. Use plot2d with histogram=1.
##
## See: histo, plot2d
	mi=min(d); ma=max(d);
	if mi~=ma; ma=mi+1; endif;
	if integer; n=floor(ma-mi)+1; ma=ma+0.9999; endif;
	x=zeros(1,2*n+2); y=zeros(1,2*n+2);
	h=(d-mi)/(ma-mi)*n;
	c=count(h,n+1); c[n]=c[n]+c[n+1]; c=c[1:n];
	y[2:2:2*n]=c; y[3:2:2*n+1]=c;
	xx=linspace(mi,ma,n);
	x[2:2:2*n]=xx[1:n]; x[3:2:2*n+1]=xx[2:n+1];
	x[1]=mi; x[2*n+2]=ma;
	w=linewidth(width); xplot(x,y,grid,ticks); linewidth(w);
	return plot;
endfunction
