function linfit(x,y,ffunction)
##Returns a vector representing the parameters 
##used to create a linear combination of the functions 
##in ffunction(x,...
## x - vector (matrix) of independent variable(s) 
## y - vector of dependent variable (the same length as x)
## ffunction(x,... - returns a vector whose elements 
## are functions making up a linear function
## Example:
## given: vectors - x,y
## function: y = b_1 + b_2/x + b_3*log10(x) + b_4*x^2
## ..
## function ffunction(x)
##  return [1,1/x,log10(x),x^2];
## endfunction;
##..
## linfit returns vector: b_1,b_2,b_3,b_4
m=cols(x);
A=ffunction(x[:,1],args());
loop 2 to m;
   A=A_ffunction(x[:,#],args()); 
end;
return fit(A,y')';
endfunction;
