comment
exports findhull()
endcomment

//V.0.1 nov2009 several changes in findhull

function %orient(m) ...
## lowlevel routine, no errorchecking
	l:=rows(m);
	d=ones(l,l);
	loop 1 to l
		d[#,2:l]=m[#,:];
	end
	return sign(det(d))
endfunction

function findhull (points:numerical)
## finds hull of 2-dimensional data 
## stored in matrix points with each row a point
	if rows(points)<3 then return points; endif
	rest=lexsort(points);
	first=rest[1];
	i=rest==first;
	rest=rest[nonzeros(i[:,1]+i[:,2]<2)];  // delete _all firsts, shouldnt be necessary but it is, somewhat strange
	s=rest-first;
	l=rows(s);
	errors off; // n/0 returns NAN now
	s=s[:,1]/s[:,2];
	errors on;
	s[nonzeros(isNAN(s))]=1e399;   //because lexsort doesnt sort nans 
	s=s|(1:l)';
	s=lexsort(s); // keeps order of equal numbers
	i=find(s[:,1],0);
	if !i then i=1; endif
	repeat
	 if i>1 then if s[i-1,1]==0 then i=i-1; else break; endif; else break; endif;
	end
	if s[i,1]<0 then i=i+1; endif 
	x:=s[i:l,2];
	if i>1 then x=x_s[1:i-1,2]; endif
	rest=rest[x]_first;
	loop 1 to l+1
	  repeat
	   if (rows(first)==1) then break; endif
	   if (%orient(rest[#]_first[-1]_first[-2])>0)||all(rest[#]==first[-2]) then 
	    break; 
	   else 
	    first=first[1:rows(first)-1];
	   endif
	  end 
	  first:=first_(rest[#]);
	end
	return first[1:rows(first)-1];
endfunction
