load testfunctions;

reset();
longestformat;

test("1+1",2)
test("1-1",0)
test("I+1",I+1)
test("I+1i",2*I)

testapprox("~0,1~+~0,1~",~0,2~)
testapprox("~-1,1~+~-2,1~",~-3,2~)
testapprox("~0,1~-~0,1~",~-1,1~)
testapprox("~-1,1~-~-1,1~",~-2,2~)

test("-4*5",-20)
test("4*-5",-20)
test("-4*-5",20)
test("I*I",-1)
test("(1+I)*(1+I)",2i)
testapprox("~0,1~*~0,1~",~0,1~)
testapprox("~-1,1~*~-1,1~",~-1,1~)
testapprox("~1,2~*~-1,1~",~-2,2~)
testapprox("~-1,2~*~0,1~",~-1,2~)
testapprox("~-1,2~*~-2,1~",~-4,2~)
testapprox("~0~*~0~",~0~)
testapprox("~2~*~2~",~4~)
testapprox("~-2~*~-2~",~4~)
testapprox("~-2~*~2~",~-4~)

test("1/(1e300*1e300)",0)
testerror("sqrt(-1)");

test("3/2",1.5)
test("3/-2",-1.5)
test("-3/2",-1.5)
test("-3/-2",1.5)

testerror("1/0")
test("I/I",1)

test("(1+I)/(1+2i)",0.6-1/5*I)
testerror("I/0")


testapprox("~-2,2~/2",~-1,1~)
testapprox("~-2,2~/-2",~-1,1~)
testapprox("~0,2~/2",~0,1~)
testapprox("~2~",2)
testerror("~1,2~/~0,2~")
testapprox("expand(1,1)",~0,2~)
testapprox("11",~0,2~)

test("~0,2~&&~1,3~",~1,2~);
testerror("~0,2~&&~4,5~");
test("~0,2~||~1,3~",~0,3~);
test("~-6,2~||~4,5~",~-6,5~);
test("~-6,2~<<~1,5~",0);
test("~1,2~<<~1,5~",1);

test("2>3 && 5>4",0)
test("2>3 || 5>4",1)
test("2>3 || 5>4",1)

test("bitand(2^8+2^9,2^8)",2^8)
test("bitor(2^8+2^9,2^8)",2^8+2^9)
test("bitor(bitnot(3345),3345)",2^32-1)

test("[1,2,3]",1:3)
testapprox("(0:0.01:1)[-1]",1)
test("linspace(0,1,100)[-1]",1)
test("[1;1,1]",[1,0;1,1])
test("[1;1]",ones(2,1))
test("[1;1]'",ones(1,2))
test("[1,1]'",ones(1,2))
test("[1,2,3;4,5]'[2]",[2,5])
test("[1,2,3;4,5][2,3]",0)
testerror("[1,2,3;4,5][3,2]")
test("redim(1:6,2,3)",[1,2,3;4,5,6])
test("redim(1:6,2,3)[1]",[1,2,3])
test("redim(1:6,2,3)[:,1]",[1;4])
test("redim(1:6,2,3)[:,:]",[1,2,3;4,5,6])
test("redim(1:6,2,3)[-1]",[4,5,6])
test("redim(1:6,2,3)[:,-1]",[3;6])
test("(1:6)[-2:-1]",[5,6])
test("redim(1:6,2,3)[[-1,-2]]",[4,5,6;1,2,3])
test("redim(1:6,2,3)[:,[3,2,1]]",[3,2,1;6,5,4])
test("flipx(flipx(1:5))",1:5)
test("flipy(flipy((1:5)'))'",1:5)
test("rotleft(rotright(1:5))",1:5)
test("rotright(rotleft((1:5)'))'",1:5)
A=redim(1:12,3,4); 
test("setdiag(complex(A),0,diag(A,0))",complex(A))
test("setdiag(A,1,diag(A,1))",A)
test("setdiag(A,-1,diag(A,-1))",A)
test("shiftleft(A)",A[1:3,2:4]|0)
test("shiftright(A)",0|A[1:3,1:3])

test("sum(1:100)",50*101)
test("prod(1:100)",100!)
test("cumsum(1:100)[-1]",50*101)
test("sum(zeros(1,0))",0)
test("prod(zeros(1,0))",1)

v=1:10; 
test("max(v,flipx(v))+min(v,flipx(v))",11*ones(size(v)))
test("extrema(shuffle(v))[[1,3]]",[1,10])

loop 1 to 100; test("sort(shuffle(1:100))",1:100); end;
v=shuffle(1:100); {w,i}=sort(v); test("v[i]",w);

A=redim(1:6,2,3); 
test("A.A'",[14,32;32,77])
testerror("A.A")
test("A.sum(A')",[46;109])
b=sum(A.A'); testapprox("(A.A')\b",ones(2,1))
b=sum(A'.A); testapprox("det(A'.A)",0); testerror("(A'.A)\b")
{B,r,c,det}=lu(A'.A); test("cols(r)<3",1)
A=redim(1:9,3,3); testerror("A\sum(A)")
p=[1e-30,2,-1e-30]; test("xpolyval(p,1)",2)
H=hilbert(10); test("xlgs(H,sum(H))",1)

s=0; loop 1 to 100; s=s+#; end; test("s",50*101)
s=0; for i=1 to 100; s=s+i; end; test("s",50*101)
s=0; for i=1 to 101 step 2; s=s+i; end; test("s",51*51)
s=0; for i=101 to 1 step -2; s=s+i; end; test("s",51*51)
s=0; for i=1 to -1; s=s+i; end; test("s",0)

s=4; if s==4 then x=1; else x=2; endif; test("x",1)
s=2; if s==4 then x=1; else x=2; endif; test("x",2)
s=5; if s==4 then x=1; elseif s==5 then x=2; else x=3; endif; test("x",2)
s=6; if s==4 then x=1; elseif s==5 then x=2; else x=3; endif; test("x",3)
s=6; if not s==4 then x=1; elseif s==5 then x=2; else x=3; endif; test("x",1)
s=6; if s==4 then x=1; elseif not s==5 then x=2; else x=3; endif; test("x",2)

function f(x,y)
	s=0;
	loop 1 to x; if #>y then break; endif; s=s+#; end;
	return s;
endfunction

test("f(10,15)",sum(1:10))
test("f(10,5)",sum(1:5))

function f(x,y)
	s=0;
	for i=1 to x; if i>y then break; endif; s=s+i; end;
	return s;
endfunction

test("f(10,15)",sum(1:10))
test("f(10,5)",sum(1:5))

function f(x,y)
	s=0; i=1;
	repeat if i>y or i>x then break; endif; s=s+i; i=i+1; end;
	return s;
endfunction

test("f(10,15)",sum(1:10))
test("f(10,5)",sum(1:5))

function f(x)
	if x>0 then return 1;
	elseif x==0 then return 0;
	else if x<0 then return -1 endif;
	endif
endfunction

test("f(-2)",-1)
test("f(-2)",-1)
test("f(2)",1)
test("f(2)",1)
test("f(0)",0)
test("f(0)",0)

testapprox("asin(sin(1))",1)
testapprox("sin(arcsin(-0.5))",-0.5)
testapprox("sin(45)",1/sqrt(2))
testapprox("acos(cos((0:1:180)))",(0:1:180))
testapprox("cos(arccos(0))",0)
testapprox("arccos(0)",pi/2)
testapprox("atan(tan(1))",1)
testapprox("tan(arctan(-20))",-20)
testapprox("exp(log(2))",2)
testapprox("log(exp(-2))",-2)
testapprox("ln(exp(0))",0)

testapprox("invnormaldis(normaldis(1))",1);
x=-2:0.1:2; y=invnormaldis(normaldis(x)); test("abs(y-x)<1e-3",1);

test("-2^2",-4)
test("2^-2",1/4)
test("(-2)^-2",1/4)
test("(-2)^(1/3)",-2^(1/3))
testerror("(-2)^(1/4)")
test("2^3^2",2^9)
test("2^3/3",8/3)
test("2^-3/3",1/24)
test("2^0",1)
test("(-2)^0",1)
test("0^0",1)
test("0^2",0)
test("0^0",1)

testerror("(2+2)^^2")
testerror("(2+2)(2-1)")
testerror("(2+2)[0]")
test("--2",2)
test("2**2",4)

function f(x) := x^x
a=bisect("x^x-2",1,2); testapprox("a^a",2)
a=bisect("f",1,2,y=2); testapprox("a^a",2)
a=bisect("x^x",1,2,y=2); testapprox("a^a",2)
a=secant("x^x",1,2,y=2); testapprox("a^a",2)
a=secant("x^x",1.5,y=2); testapprox("a^a",2)
a=newton("x^x","x^x*(log(x)+1)",1,2,y=2); testapprox("a^a",2)
function f(v) := [v[1]^3*v[2]-v[2]^2+1,v[1]-v[2]^2]
function Df(v) := [3*v[1]^2*v[2],v[1]^3-2*v[2];1,-2*v[2]]
a=newton2("f","Df",[-1,-1]); testapprox("f(a)",[0,0])

testapprox(''romberg("x^2",0,1)'',1/3)
testapprox(''gauss("x^19",0,1)'',1/20)
testapprox(''integrate("x^2",0,1)'',1/3)

sqrt2=iterate("(x+2/x)/2",2); testapprox("sqrt2",sqrt(2))
testapprox(''iterate("(x+2/x)/2",2)'',sqrt(2))
sqrt2=iterate("(x+2/x)/2",2,10); testapprox("sqrt2[-1]",sqrt(2))
sqrt2=sequence("(x[n-1]+2/x[n-1])/2",2,10); testapprox("sqrt2[-1]",sqrt(2))

t=(0:19)*2*pi/20; A=cos(t')|sin(t'); b=2*cos(t')+2*sin(t')+1;
x=simplex(A,b,[1,0],max=1); testapprox("x[1]",3);
x=intsimplex(A,b,[1,0],max=1); testapprox("x[2]",2);
t=(0:19)*2*pi/20; A=cos(t')|sin(t'); b=ones(size(t'));
x=simplex(A,b,[1,1],min=1); testapprox("x[1]+x[2]",0);
x=simplex(A,b,[1,0],min=1,restrict=0); testapprox("x[1]",-1);

load lpsolve;
f=[592, 381, 273, 55, 48, 37, 23];
A=[3534, 2356, 1767, 589, 528, 451, 304];
b=[119567];
e=[-1];
{xopt,opt}=ilpsolve(A,b,f,e,max=1);
test("xopt[1]",32);

function f(x:number)
	if x>0 then return x else return -x endif;
endfunction
test("fmap(-5:5)",abs(-5:5))
test(''map("f",-5:5)'',abs(-5:5))
testerror("f(1:5)")
testerror("f(I)")

function f(n:natural)
	if n<2 then return 1;
	else return n*f(n-1);
	endif;
endfunction
test("f(5)",5!)
test("f(0)",1)
testerror("f(1:10)");

a=5;
function f(x)
	x=10;
endfunction
f(a); test("a",5);
function f(%x)
	%x=10;
endfunction
f(a); test("a",10);
function g(%x)
	f(%x);
endfunction
a=5; g(a); test("a",10);
function f(v)
	v[1]=10;
endfunction
v=1:5; f(v); test("v[1]",10)

function f(x,a,b=3) := a*b*x
test("f(2,3,4)",24)
test("f(2,3)",18)
test("f(2,5,b=2)",20)
test("f(2,5,b=2)",20)
function f(x,a) := a*b*x
clear b; testerror("f(2,5)")
b=3; test("f(2,5)",30);
b=3; test(''"f(x,5)"(2)'',30)
function f(x,a,b) := a*b*x
test(''"f(x,5,c)"(2,c=4)'',40)

function f(a,[x,y],b=4) := a*b*x*y
test("f(1,-1,1)",-4)
test("f(1,[2,3],-1)",-6)
v=[2,3]; test("f(1,v)",24)

test(''"affe"|"berta"'',"affeberta")
test(''"affe"|22'',"affe22")
test(''"affe"=="berta"'',0)
test(''"affe"<"berta"'',1)
test(''"affe">"berta"'',0)
test(''stringcompare("affe","berta")'',-1)
test(''substring("affe",2,-1)'',"ffe")
test(''strfind("affe","fe",1)'',3)
test(''strlen("affe")'',4)
test(''strlen("")'',0)
test(''tolower(toupper("affe"))'',"affe");

test("round(pi,0)",3)
test("round(2.555,2)",2.56)
test("round(-2.5,0)",-3)
test("floor(2.9)",2)
test("floor(-2.9)",-3)
test("ceil(2.9)",3)
test("ceil(-2.9)",-2)
testerror("real(1+0.0001i)")
test("real(I^2)",-1)

test("sum(bin(10,0:10))",2^10)
testapprox("sum(1/(0:20)!)",E)

n=1:1000; test("any(isprime(n) && n>500 && n<510)",1)
n=1:1000; test("nonzeros(isprime(n) && n>500 && n<510)",[503,509])

function testeps (eps,x,y)
	localepsilon(eps);
	return x~=y
endfunction
test("testeps(0.001,1,1.0005)",1)
test("1~=1.0005",0)
test("testeps(epsilon(),1,1.0005)",0)

A=random(3,3);
writematrix(A,userhome()|"test.dat");
B=readmatrix(userhome()|"test.dat");
testapprox("A",B)
remove(userhome()|"test.dat");

test("round(real(ifft(fft(1:1024))),8)",1:1024)
testapprox("ifft(fft(1:16))",1:16)

A=[1,3;3,1]; 
testapprox("sort(jacobi(A))",sort(real(eigenvalues(A))))
{B,r,c,det}=lu(A);
testapprox("(band(B[r],-2,-1)+id(2)).band(B[r],0,2)",A[r])

p=polycons(1:5);
testapprox("sort(real(polysolve(p)))",1:5)
q=polymult(p,p);
testapprox("sort(real(round(polysolve(q),5)))",redim(dup(1:5,2)',1,10))

function f(x,a=6) := a*x
function g(x) := f(x;args())
test("g(2;4)",12)
test("g(2)",12)
function g(x) := f(x,args())
test("g(2;4)",8)
test("g(2)",12)

function f(expr,x) := expr(x,args());
function g(x)
	b=22;
	return f("b*x",x;b);
endfunction
test("g(2)",44)

longformat;
reset();
