; This is the EULER setup script

[Setup]
AppName=Euler Math Toolbox
AppId=Euler Mathematical Toolbox
AppVerName=Version 19.3
AppCopyright=Euler is Copyright  2001-2007 Ren Grothmann
DefaultDirName={pf}\Euler
DefaultGroupName=Euler Math Toolbox
InfoBeforeFile=eulermaxima.readme
AppPublisher=Ren Grothmann
AppPublisherURL=http://euler.rene-grothmann.de/
ChangesAssociations=yes
Compression=zip
OutputBaseFilename=EulerSetup
OutputDir=\euler\download

[Dirs]
Name: "{userdocs}\Euler Files"; Flags: uninsneveruninstall

[Tasks]
Name: associate; Description: "&Associate Euler files"; GroupDescription: "Other tasks:"

[Registry]
; Parameter quick reference:
;   "Root key", "Subkey", "Value name", Data type, "Data", Flags
Root: HKCR; Subkey: ".e"; ValueType: string; ValueName: ""; ValueData: "Euler-e"; Flags: uninsdeletekey; Tasks: associate
Root: HKCR; Subkey: ".en"; ValueType: string; ValueName: ""; ValueData: "Euler-en"; Flags: uninsdeletekey; Tasks: associate
Root: HKCR; Subkey: "Euler-e"; ValueType: string; ValueName: ""; ValueData: "Euler-e"; Flags: uninsdeletekey; Tasks: associate
Root: HKCR; Subkey: "Euler-e\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{app}\docs\euler-1.ico"; Flags: uninsdeletekey; Tasks: associate
Root: HKCR; Subkey: "Euler-e\shell\open\command"; ValueType: string; ValueName: ""; ValueData: "{app}\euler ""%1"""; Flags: uninsdeletekey; Tasks: associate
Root: HKCR; Subkey: "Euler-en"; ValueType: string; ValueName: ""; ValueData: "Euler-en"; Flags: uninsdeletekey; Tasks: associate
Root: HKCR; Subkey: "Euler-en\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{app}\docs\euler-2.ico"; Flags: uninsdeletekey; Tasks: associate
Root: HKCR; Subkey: "Euler-en\shell\open\command"; ValueType: string; ValueName: ""; ValueData: "{app}\euler ""%1"""; Flags: uninsdeletekey; Tasks: associate

[Icons]
; Parameter quick reference:
;   "Icon title", "File name", "Parameters", "Working dir (can leave blank)",
;   "Custom icon filename (leave blank to use the default icon)", Icon index
Name: "{group}\Start Euler Math Toolbox"; FileName: "{app}\euler.exe"; WorkingDir: "{app}"; IconFilename: "{app}\docs\euler-1.ico"
Name: "{userdesktop}\Euler Math Toolbox"; FileName: "{app}\euler.exe"; WorkingDir: "{app}"; IconFilename: "{app}\docs\euler-1.ico"
Name: "{group}\Uninstall Euler and Maxima"; Filename: "{uninstallexe}"

[Files]
; Parameter quick reference:
;   "Source filename", "Dest. filename", Copy mode, Flags
Source: "*"; DestDir: "{app}"
Source: "util\*"; DestDir: "{app}\util"; Flags: recursesubdirs
Source: "dll\*"; DestDir: "{app}\dll"; Flags: recursesubdirs
Source: "docs\*"; DestDir: "{app}\docs"; Flags: recursesubdirs
Source: "\euler\share\*"; DestDir: "{app}\share"; Flags: recursesubdirs
Source: "\euler\info\*"; DestDir: "{app}\info"; Flags: recursesubdirs
Source: "\euler\maxima\*"; DestDir: "{app}\maxima"; Flags: recursesubdirs
Source: "\euler\gnuplot\*"; DestDir: "{app}\gnuplot"; Flags: recursesubdirs
Source: "\euler\tcc\*"; DestDir: "{app}\tcc"; Flags: recursesubdirs
Source: "regular.ttf"; DestDir: "{app}"; FontInstall: "Source Code Pro"; Flags: uninsneveruninstall
Source: "bold.ttf"; DestDir: "{app}"; FontInstall: "Source Code Pro Bold"; Flags: uninsneveruninstall

[UninstallDelete]
Type: filesandordirs; Name: "{app}"
