#include "dlldef.h"
#include <stdio.h>

int iter (double a1, double b1)
{
	double a=0,b=0;
	int n=0;
	while(1)
	{
		double r=a*a+b*b;
		if (r>=100) return n;
		if (n>=100) break;
		double ha=a*a-b*b-a1;
		b=2*a*b-b1;
		a=ha;
		n++;
	}
}

EXPORT char * mandel (header *hd[], int np, char *ramstart, char *ramend)
{
	start(ramstart,ramend); // required !!!
	
	CHECK(np==2,"Need 2 parameters for mandel");

	CHECK(hd[0]->type==s_cmatrix,"Need a complex matrix for mandel");
	
	double *min=matrixof(hd[0]);
	int n=dimsof(hd[0])->r,m=dimsof(hd[0])->c;
	
	int maxiter=getint(hd[1]);
	IFERROR("Need an integer for the maximal number of iterations");
	if (maxiter<10) maxiter=10;
	
	header *result=new_matrix(n,m);
	CHECK(result,"Out of stack space.");
	double *res=matrixof(result);
	
	int i;
	for (i=0; i<n*m; i++)
	{
		res[i]=iter(min[2*i],min[2*i+1]);
		if (test_key()==escape)
		{
			ERROR("User Interrupted.");
		}
	}
	
	return newram;
}